<?php
class tipoitemActions extends wtActions
{
    public function executeIndex()
    {
        
    }
    
    public function executeList()
    {
        LayoutTemplate::getInstance()->setUseBootstrap();
    	$this->block = $this->getRequestParameter( 'block' );
    	
    }
    
    public function executeGrid()
    {
       
        $block = $this->getRequestParameter( 'block' );
        $page  = $this->getRequestParameter( 'page' );
        
         set_header_utf8();
        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        $o_GridAction = new GridAction();
        $o_GridAction->setClassFind( new ALM_ItemTipoFN() );
        
        $o_GridAction->addConditionFilter( "DescripcionLocal", ALM_ItemTipoFN::DescripcionLocal, "LIKE", "%%s%" );
        
        $o_GridAction->addOrder( "DescripcionLocal", ALM_ItemTipoFN::DescripcionLocal);
        $o_GridAction->addOrder( "Estado", ALM_ItemTipoFN::Estado );
        
        $o_GridAction->addOrderDefault( ALM_ItemTipoFN::IdItemTipo , true );
        
        $o_GridAction->addRowsToShow( "IdItemTipo", "CodigoSunat", "DescripcionLocal", "Estado", "TransacciondelSistema" );
        
        $o_GridAction->setNumberRecordsShow( 15 );
        
        $o_GridAction->initialize();
        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        $a_ResultJson['page']    = $o_GridAction->getPage();
        $a_ResultJson['total']   = $o_GridAction->getTotalPage();
        $a_ResultJson['records'] = $o_GridAction->getTotalRecords();
        $a_ResultJson['rows']    = $o_GridAction->getResultArray();
        //pr( $a_ResultJson );
        echo json_encode( $a_ResultJson );

        return ViewResponse::NONE;   
    }
    
    
   
    public function executeAddedit()
    {
        LayoutTemplate::getInstance()->setUseBootstrap();
        $this->block      = $this->getRequestParameter( 'block' );
        $this->i_Id       = $this->getRequestParameter( 'i_Id' );
        $this->s_TipoProc = $this->getRequestParameter( 's_TipoProc' );
        
                
        $this->s_Titulo = "Nuevo Tipo Item";
        
         /************/
        
        $o_ALM_ItemTipoBN = new ALM_ItemTipoBN();
        $o_ALM_ItemTipoBN->setEstado('A');
        $this->o_ALM_ItemTipoBN = $o_ALM_ItemTipoBN;
        
        /*************/
        
        //$this->o_ALM_ItemTipoBN = new ALM_ItemTipoBN();
        if( $this->s_TipoProc == "upd" )
        {
            $this->s_Titulo = "Editar Tipo Item";
            $o_ALM_ItemTipoFN = new ALM_ItemTipoFN();
            $this->o_ALM_ItemTipoBN = $o_ALM_ItemTipoFN->selectByPK( $this->i_Id );
        }
    }
   
    public function executeSaveAddEdit()
    {
        $block      = $this->getRequestParameter( 'block' );
        $i_Id       = $this->getRequestParameter( 'i_Id' );
        $s_TipoProc = $this->getRequestParameter( 's_TipoProc' );
        $TypeSub    = $this->getRequestParameter( 'TypeSub' );
        
        $IdItemTipo  = $this->getRequestParameter( 'IdItemTipo' );
        $Descripcion = $this->getRequestParameter( 'DescripcionLocal' );
        $Estado      = $this->getRequestParameter( 'Estado' );
        $CodigoSunat = $this->getRequestParameter( 'CodigoSunat' );

        $VerDiaSemanaFlag  = $this->getRequestParameter( 'VerDiaSemanaFlag' );
        $IngenieriaFlag    = $this->getRequestParameter( 'IngenieriaFlag' );
        $TransacciondelSistemaFlag    = $this->getRequestParameter( 'TransacciondelSistemaFlag' ) ? "1" : "0";
        $DescripcionIngles = $this->getRequestParameter( 'DescripcionIngles' );

        try         
        
        {            
        	$o_ALM_ItemTipoDP = new ALM_ItemTipoDP();
        	$o_ALM_ItemTipoDP->setCodigoSunat( $CodigoSunat );
            $o_ALM_ItemTipoDP->setDescripcionLocal( $Descripcion );
            $o_ALM_ItemTipoDP->setEstado( $Estado );
            $o_ALM_ItemTipoDP->setVerDiaSemanaFlag( $VerDiaSemanaFlag );
            $o_ALM_ItemTipoDP->setIngenieriaFlag( $IngenieriaFlag );
            $o_ALM_ItemTipoDP->setTransacciondelSistemaFlag( $TransacciondelSistemaFlag );
            $o_ALM_ItemTipoDP->setDescripcionIngles( $DescripcionIngles );
            
            if( $s_TipoProc == "nvo" )
            {
                //NUEVO
                $IdItemTipo = ALM_ItemTipoDP::recuperarId();
                $o_ALM_ItemTipoDP->setIdItemTipo( $IdItemTipo );
                $o_ALM_ItemTipoDP->setFechaCreacion( date( "Y-m-d H:i:s" ) );
                $o_ALM_ItemTipoDP->setUsuarioCreacion( myUser::getUser()->getUserId() );
                $o_ALM_ItemTipoDP->setFechaModificacion( date( "Y-m-d H:i:s" ) );
                $o_ALM_ItemTipoDP->setUsuarioModificacion( myUser::getUser()->getUserId() );
                $b_Result = $o_ALM_ItemTipoDP->save();
                $i_Id = $IdItemTipo;
            }
            else 
            {
                //UPDATE
                //$i_Id = ( int ) $this->getRequestParameter( 'i_Id' );
                $o_ALM_ItemTipoDP->setIdItemTipo( $i_Id );
                $o_ALM_ItemTipoDP->setFechaModificacion( date( "Y-m-d H:i:s" ) );
                $o_ALM_ItemTipoDP->setUsuarioModificacion( myUser::getUser()->getUserId() );
                $b_Result = $o_ALM_ItemTipoDP->update();
            }
            
            $a_Rs['type_sub'] = $TypeSub;
            $a_Rs['error']    = false;
            $a_Rs['id']       = $i_Id;
        }
        catch ( Exception $o_Exception )
        {
            $a_Rs['error']         = true;
            $a_Rs['mensaje_error'] = $o_Exception->getMessage();
        }
        echo json_encode( $a_Rs );
        return ViewResponse::NONE;
    }
    
    public function executeAudi()
    {
        $block          = $this->getRequestParameter( 'block' );
        $i_Id           = $this->getRequestParameter( 'i_Id' );
        $this->s_Topico = "Tipo de Item";
        $o_ALM_ItemTipoFN = new ALM_ItemTipoFN();
        $this->o_ObjectBN = $o_ALM_ItemTipoFN->selectByPK( $i_Id );
    }
    
    public function executeViewdel()
    {
        $this->block      = $this->getRequestParameter( 'block' );
        $this->i_Id       = $this->getRequestParameter( 'i_Id' );
        $this->s_TipoProc = $this->getRequestParameter( 's_TipoProc' );
       
        
        $o_ALM_ItemTipoFN = new ALM_ItemTipoFN();
        $this->o_ALM_ItemTipoBN = $o_ALM_ItemTipoFN->selectByPK( $this->i_Id );
    }
    
    /* public function executeDeleteRow()
    {
        $block      = $this->getRequestParameter( 'block' );
        $i_Id       = $this->getRequestParameter( 'i_Id' );
        $s_TipoProc = $this->getRequestParameter( 's_TipoProc' );
        try 
        {
            $o_MST_UnidadMastDP = new MST_UnidadMastDP();
            $o_MST_UnidadMastDP->setIdUnidad( $i_Id );
            $o_MST_UnidadMastDP->delete();

            $a_Rs['error']   = false;
            $a_Rs['id']      = $i_Id;
        }
        catch ( Exception $o_Exception )
        {
            $a_Rs['error']   = true;
            $a_Rs['mensaje_error_ex'] = $o_Exception->getMessage();
            $a_Rs['mensaje_error'] = "No se pudo eliminar el registro.";
        }
        echo json_encode( $a_Rs );
        return ViewResponse::NONE;
    }*/
    
    
    public function executeDeleteRow()
    {
        $block      = $this->getRequestParameter( 'block' );
        $i_Id       = $this->getRequestParameter( 'i_Id' );
        $s_TipoProc = $this->getRequestParameter( 's_TipoProc' );
        
        try 
        {
        	
            $o_ALM_ItemTipoDP = new ALM_ItemTipoDP();
           // $o_MST_UnidadMastDP->setIdUnidad( $i_Id );
            $o_ALM_ItemTipoDP->setIdItemTipo($i_Id );
            //$o_ALM_ItemTipoDP->delete();

            $a_Rs['error']   = false;
            $a_Rs['id']      = $i_Id;
        }
        catch ( Exception $o_Exception )
        {
            $a_Rs['error']   = true;
            $a_Rs['mensaje_error_ex'] = $o_Exception->getMessage();
            $a_Rs['mensaje_error'] = "No se pudo eliminar el registro.";
        }
        echo json_encode( $a_Rs );
        return ViewResponse::NONE;
    }
}